Attribute VB_Name = "Module2"
Private Declare Function RasEnumConnections Lib "rasapi32.dll" Alias "RasEnumConnectionsA" (lprasconn As Any, lpcb As Long, lpcConnections As Long) As Long
Private Declare Function RasGetConnectStatus Lib "rasapi32.dll" Alias "RasGetConnectStatusA" (ByVal hRasConn As Long, lpRASCONNSTATUS As Any) As Long
Public Declare Function RasHangUp Lib "rasapi32.dll" Alias "RasHangUpA" (ByVal hRasConn As Long) As Long

Private Const RAS95_MaxEntryName = 256
Private Const RAS_MaxDeviceType = 16
Private Const RAS95_MaxDeviceName = 128
Private Const RASCS_DONE = &H2000&
Public connected As Integer
Public timeleft
Public Type RASCONN95
    dwSize As Long
    hRasConn As Long
    szEntryName(RAS95_MaxEntryName) As Byte
    szDeviceType(RAS_MaxDeviceType) As Byte
    szDeviceName(RAS95_MaxDeviceName) As Byte
End Type

Public Type RASCONNSTATUS95
    dwSize As Long
    RasConnState As Long
    dwError As Long
    szDeviceType(RAS_MaxDeviceType) As Byte
    szDeviceName(RAS95_MaxDeviceName) As Byte
End Type

Public TRasCon(255) As RASCONN95
Public lg As Long
Public lpcon As Long
Public lReturn As Long
Public Tstatus As RASCONNSTATUS95

Public ret As Long

Public Function IsRASConnected() As Boolean
    
    TRasCon(0).dwSize = 412
    lg = 256 * TRasCon(0).dwSize
    lReturn = RasEnumConnections(TRasCon(0), lg, lpcon)
    
    If lReturn Then
    MsgBox "ERROR"
    Exit Function
    End If
    
    Tstatus.dwSize = 160
    lReturn = RasGetConnectStatus(TRasCon(0).hRasConn, Tstatus)
    
    If Tstatus.RasConnState = RASCS_DONE Then
        IsRASConnected = True
    Else
        IsRASConnected = False
    End If
End Function

