VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Radio Station (Server)"
   ClientHeight    =   3270
   ClientLeft      =   4875
   ClientTop       =   4125
   ClientWidth     =   5190
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   3270
   ScaleWidth      =   5190
   StartUpPosition =   2  'CenterScreen
   Begin MSComctlLib.StatusBar StatusBar 
      Align           =   2  'Align Bottom
      Height          =   375
      Left            =   0
      TabIndex        =   4
      Top             =   2895
      Width           =   5190
      _ExtentX        =   9155
      _ExtentY        =   661
      Style           =   1
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
      EndProperty
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "<"
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "Webdings"
         Size            =   20.25
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3480
      TabIndex        =   2
      ToolTipText     =   "Stop Transmission"
      Top             =   1800
      Width           =   975
   End
   Begin MSWinsockLib.Winsock sckServer 
      Left            =   120
      Top             =   2400
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
      Protocol        =   1
      RemoteHost      =   "238.238.238.238"
      RemotePort      =   1024
      LocalPort       =   1023
   End
   Begin VB.ComboBox cmbSelDev 
      Height          =   315
      Left            =   1800
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   720
      Width           =   2655
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "4"
      BeginProperty Font 
         Name            =   "Webdings"
         Size            =   20.25
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   1800
      Style           =   1  'Graphical
      TabIndex        =   0
      ToolTipText     =   "Start Transmission"
      Top             =   1800
      Width           =   975
   End
   Begin VB.Image imgSnd 
      Height          =   480
      Left            =   4680
      Picture         =   "frmMain.frx":044A
      Top             =   2400
      Width           =   480
   End
   Begin VB.Label lblDevice 
      AutoSize        =   -1  'True
      Caption         =   "Capture Device :"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   240
      TabIndex        =   3
      Top             =   720
      Width           =   1485
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim dx As New DirectX8
Dim dsenum As DirectSoundEnum8
Dim dsc As DirectSoundCapture8
Dim dscb As DirectSoundCaptureBuffer8
Dim dscbd As DSCBUFFERDESC
Implements DirectXEvent8
Dim psary(3) As DSBPOSITIONNOTIFY
Dim appbuff() As Byte
Dim X As Integer
Dim Y As Integer
Dim devguid As String
Dim TaskID As Long
Const FormatTag = WAVE_FORMAT_PCM, Channels = 1
Const SamplesPerSec = 11025, BitsPerSample = 16
Const RemoteHost = "238.238.238.238", RemotePort = 1024, Bind = 1023

Private Sub cmbSelDev_click()
    Y = cmbSelDev.ListIndex
    devguid = dsenum.GetGuid(Y + 1)
End Sub

Private Sub cmdStart_Click()
    dscb.Start (DSCBSTART_LOOPING)
    cmdStart.Enabled = False
    cmdStop.Enabled = True
    cmbSelDev.Enabled = False
    StatusBar.SimpleText = "Transmitting Audio..."
End Sub

Private Sub cmdStop_Click()
    dscb.Stop
    cmdStart.Enabled = True
    cmdStop.Enabled = False
    cmbSelDev.Enabled = True
    StatusBar.SimpleText = "Transmission Stopped"
End Sub

Private Sub DirectXEvent8_DXCallback(ByVal eventid As Long)
    Select Case eventid

    Case psary(0).hEventNotify
        dscb.ReadBuffer 0, 7350, appbuff(0), DSCBLOCK_DEFAULT
        sckServer.SendData appbuff()
    Case psary(1).hEventNotify
        dscb.ReadBuffer 7350, 7350, appbuff(0), DSCBLOCK_DEFAULT
        sckServer.SendData appbuff()
    Case psary(2).hEventNotify
        dscb.ReadBuffer 14700, 7350, appbuff(0), DSCBLOCK_DEFAULT
        sckServer.SendData appbuff()

    End Select
End Sub


Private Sub Form_Load()
    With sckServer
            .RemoteHost = RemoteHost
            .RemotePort = RemotePort
            .Bind Bind
    End With

    ReDim appbuff(7350)

    Set dsenum = dx.GetDSCaptureEnum
    
    For X = 1 To dsenum.GetCount
        cmbSelDev.AddItem dsenum.GetDescription(X)
    Next X

    Set dsc = dx.DirectSoundCaptureCreate(devguid)

    With dscbd.fxFormat
        .nFormatTag = FormatTag
        .nChannels = Channels
        .lSamplesPerSec = SamplesPerSec
        .nBitsPerSample = BitsPerSample
        .nBlockAlign = .nBitsPerSample / 8 * .nChannels
        .lAvgBytesPerSec = .lSamplesPerSec * .nBlockAlign
        .nSize = 0
    End With
    dscbd.lFlags = DSBCAPS_GLOBALFOCUS Or DSBCAPS_GETCURRENTPOSITION2 _
    Or DSBCAPS_CTRLPOSITIONNOTIFY
    dscbd.lBufferBytes = dscbd.fxFormat.lAvgBytesPerSec

    Set dscb = dsc.CreateCaptureBuffer(dscbd)

    psary(0).hEventNotify = dx.CreateEvent(Me)
    psary(0).lOffset = 7350 - 1
    psary(1).hEventNotify = dx.CreateEvent(Me)
    psary(1).lOffset = 14700 - 1
    psary(2).hEventNotify = dx.CreateEvent(Me)
    psary(2).lOffset = 22050 - 1

    dscb.SetNotificationPositions 3, psary()
End Sub

Private Sub imgSnd_Click()
    TaskID = Shell("sndvol32.exe /small/r", vbNormalFocus)
End Sub
