VERSION 5.00
Begin VB.Form frmAutoExec 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   435
   ClientLeft      =   15
   ClientTop       =   15
   ClientWidth     =   1395
   ControlBox      =   0   'False
   Icon            =   "frmAutoExec.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   435
   ScaleWidth      =   1395
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
   Begin VB.Timer tmrUpdateUserStats 
      Interval        =   1000
      Left            =   960
      Top             =   0
   End
   Begin VB.Timer tmrUserInput 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   480
      Top             =   0
   End
   Begin VB.Timer chkInetStatus 
      Interval        =   1000
      Left            =   0
      Top             =   0
   End
End
Attribute VB_Name = "frmAutoExec"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Public Sub chkInetStatus_Timer()
If IsRASConnected() = True Then
  chkInetStatus.Enabled = False
  AlreadyConnected = True
  If frmMain.Visible = False Then
    Load frmMain
    frmMain.Visible = True
  End If
  frmMain.ClearDetails
  tmrUserInput.Enabled = True
 'Else
  'If frmMain.Visible = True Then
  '  chkInetStatus.Enabled = False
  '  AlreadyConnected = False
  'End If
End If
End Sub

Public Sub Form_Activate()
If AutoExecEnabled = False Then
  chkInetStatus.Enabled = False
 Else
  chkInetStatus.Enabled = True
End If
End Sub

Private Sub Form_Load()
If App.PrevInstance = True Then
  End
End If

DisableTimers
FetchRegConstants

If AutoExecEnabled = True Then
  SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\MICROSOFT\WINDOWS\CURRENTVERSION\RUN", "SurfMonitor", App.Path & "\" & App.EXEName & ".exe"
  AddToTray LoadPicture(ENICONPATH), "Surf Monitor Autodetect Enabled", frmAutoExec
 Else
  AddToTray LoadPicture(DISICONPATH), "Surf Monitor Autodetect Disabled", frmAutoExec
End If

InitDB
UpdateUserSurfTimes
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
If frmMain.Visible = False Then
  Action = RespondToTray(X)
  If Action = 1 Then
    Load frmMain
    frmMain.Visible = True
   ElseIf Action = 2 Then
    Load frmConsole
    frmConsole.Visible = True
  End If
End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
chkInetStatus.Enabled = False
tmrUpdateUserStats.Enabled = False
RemoveFromTray frmAutoExec.Icon, frmAutoExec
End Sub

Private Sub tmrUpdateUserStats_Timer()
If DateDiff("d", NOWdate, Date) > 0 Then
  tmrUpdateUserStats.Enabled = False
  NOWdate = FormatDateTime(Date, vbShortDate)
  
  If frmMain.Timer.Enabled = True Then
    frmMain.Timer.Enabled = False
    UpdateUserStats frmMain.txtSurfTime
    UpdateUserSurfTimes
    
    Set RS = DB.OpenRecordset("select * from SurfMonitor where user_id=" & Userid & "")
    With RS
     frmMain.txtSurfTime.Text = !RemSurfTime
     .Close
    End With
    frmMain.Timer.Enabled = True
   Else
    UpdateUserSurfTimes
  End If
      
  'removing log-file contents if necessary
  If LOGCONSTANT = True Then
    Open App.Path & "\UserDets.sfm" For Output As #1
    Close #1
    SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "Cdate", Date
  End If
          
  tmrUpdateUserStats.Enabled = True
End If
End Sub

Public Sub tmrUserInput_Timer()
If IsRASConnected() Then
 If TimeCount <= USERTIMELEFT Then
   frmMain.lblUserInput.Caption = ""
   frmMain.lblUserInput.Caption = "If no user input, Disconnecting in " & USERTIMELEFT - TimeCount & " secs"
 End If
 If TimeCount > USERTIMELEFT Then
  frmMain.CloseInet
  Unload frmMain
  Exit Sub
 End If
 TimeCount = TimeCount + 1
Else
 tmrUserInput.Enabled = False
 Unload frmMain
End If
End Sub
