VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{1D8A3351-C678-11D1-AA6F-000000000000}#1.0#0"; "DARTSOCK.DLL"
Begin VB.Form frmRcvMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Radio Receiver"
   ClientHeight    =   3270
   ClientLeft      =   4875
   ClientTop       =   4125
   ClientWidth     =   5190
   Icon            =   "frmRcvMain.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   3270
   ScaleWidth      =   5190
   StartUpPosition =   2  'CenterScreen
   Begin MSComctlLib.StatusBar StatusBar 
      Align           =   2  'Align Bottom
      Height          =   375
      Left            =   0
      TabIndex        =   4
      Top             =   2895
      Width           =   5190
      _ExtentX        =   9155
      _ExtentY        =   661
      Style           =   1
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
      EndProperty
   End
   Begin VB.ComboBox cmbSelDev 
      Height          =   315
      Left            =   1800
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   720
      Width           =   2655
   End
   Begin VB.CommandButton cmdPlay 
      Caption         =   "4"
      BeginProperty Font 
         Name            =   "Webdings"
         Size            =   20.25
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   1800
      TabIndex        =   1
      ToolTipText     =   "Start Playing"
      Top             =   1800
      Width           =   975
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "<"
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "Webdings"
         Size            =   20.25
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3480
      TabIndex        =   0
      ToolTipText     =   "Stop Playing"
      Top             =   1800
      Width           =   975
   End
   Begin DartSockCtl.Udp sckRcvr 
      Left            =   120
      OleObjectBlob   =   "frmRcvMain.frx":27A2
      Top             =   2400
   End
   Begin VB.Label lblDevice 
      AutoSize        =   -1  'True
      Caption         =   "Play Device :"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   240
      TabIndex        =   3
      Top             =   720
      Width           =   1185
   End
End
Attribute VB_Name = "frmRcvMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim dx As New DirectX8
Dim ds As DirectSound8
Dim dsenum As DirectSoundEnum8
Dim dssb As DirectSoundSecondaryBuffer8
Dim bufferdesc As DSBUFFERDESC
Dim appbuff() As Byte
Dim devguid As String
Dim X As Integer
Dim Y As Integer
Dim pflag As Boolean
Const FormatTag = WAVE_FORMAT_PCM, Channels = 1, SamplesPerSec = 11025
Const BitsPerSample = 16
Const Join = "238.238.238.238", Bind = 1024

Private Sub cmbSelDev_click()
    Y = cmbSelDev.ListIndex
    devguid = dsenum.GetGuid(Y + 1)
End Sub

Private Sub cmdStop_Click()
    cmdPlay.Enabled = True
    cmdStop.Enabled = False
    cmbSelDev.Enabled = True
    sckRcvr.Close
    dssb.Stop
    StatusBar.SimpleText = "Stopped"
End Sub

Private Sub cmdPlay_Click()
    cmdPlay.Enabled = False
    cmdStop.Enabled = True
    cmbSelDev.Enabled = False
    sckRcvr.Open Bind
    sckRcvr.Join Join
    sckRcvr.MaxSubnets = 100
    pflag = False
    dssb.SetCurrentPosition 0
    StatusBar.SimpleText = "Waiting For Signal..."
End Sub

Private Sub Form_Load()
    Set dsenum = dx.GetDSEnum
    For X = 1 To dsenum.GetCount
        cmbSelDev.AddItem dsenum.GetDescription(X)
    Next X
    ReDim appbuff(7350)
    With bufferdesc
        With .fxFormat
            .nFormatTag = FormatTag
            .lExtra = 0
            .nChannels = Channels
            .lSamplesPerSec = SamplesPerSec
            .nBitsPerSample = BitsPerSample
            .nBlockAlign = .nBitsPerSample / 8 * .nChannels
            .lAvgBytesPerSec = .lSamplesPerSec * .nBlockAlign
            .nSize = 0
        End With
        .lFlags = DSBCAPS_GLOBALFOCUS Or DSBCAPS_GETCURRENTPOSITION2 _
        Or DSBCAPS_CTRLPOSITIONNOTIFY
        .lBufferBytes = .fxFormat.lAvgBytesPerSec * 2
    End With
    
    Set ds = dx.DirectSoundCreate(devguid)
    ds.SetCooperativeLevel frmRcvMain.hWnd, DSSCL_PRIORITY
    Set dssb = ds.CreateSoundBuffer(bufferdesc)
End Sub

Private Sub sckRcvr_Receive()
    sckRcvr.Receive appbuff()
    dssb.WriteBuffer 0, 7350, appbuff(0), DSBLOCK_FROMWRITECURSOR

    If pflag = False Then
        dssb.Play DSBPLAY_LOOPING
        StatusBar.SimpleText = "Playing..."
        pflag = True
    End If
End Sub

