Attribute VB_Name = "Module1"
Public DATABASEPATH As String, NOWdate As String

Public AutoExecEnabled As Boolean
Public FILECREATED As Boolean
Public LOGCONSTANT As Boolean, MONUSERS As Boolean
Public ENICONPATH As String
Public LASTDATE As String
Public DISICONPATH As String
Public USERTIMELEFT As Integer, TimeCount As Integer
Dim hrs, mins, secs As Integer
Dim varLpdWflag As Long
Dim Value As String
Public AlreadyConnected As Boolean
Public Userid As Integer
Public Monitor As String
Public DB As Database, RS As Recordset
Public LRS_AccStatus As Recordset
Public LRS_TmRestrict As Recordset
Public Usernm As String, ValidateAdmin As Single
Public InetConnect As Boolean, WrittenStartDetails As Boolean
Public chkDATE As String
Public StartTIMESTAMP As String, stopTIMESTAMP As String, startDATESTAMP As String, stopDATESTAMP As String

Public Enum UserLogOptions
 [StartSurf]
 [StopSurf]
End Enum

Public Enum DateRestrictConstants
 [None]
 [EnAccountRestrictionsSet]
 [DisAccountRestrictionsSet]
End Enum

Public DtRestrict As DateRestrictConstants

Public Sub InitDB()
DATABASEPATH = App.Path & "\MonitorSurfDB.mdb"
Set DB = OpenDatabase(DATABASEPATH)
NOWdate = FormatDateTime(Date, vbShortDate)

If FILECREATED = False Then
  Open App.Path & "\UserDets.sfm" For Append As #1
  Close #1
  FILECREATED = True
  SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "FileCreated", "True"
End If

If LOGCONSTANT = True Then
  If DateDiff("d", LASTDATE, Date) >= 1 Then
    Open App.Path & "\UserDets.sfm" For Output As #1
    Close #1
    SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "Cdate", Date
  End If
End If
End Sub

Public Sub UpdateUser(NewName As String)
Set RS = DB.OpenRecordset("select * from users where user_id=" & Userid & "")

  With RS
   .Edit
   !user_pass = ENCRYPT(NewName)
   .Update
   .Close
  End With
End Sub

Public Sub AdminScreens()
With frmChgUserName
 .Caption = "Change Administrator PassKey"
 .Label1.Caption = "New PassKey"
 .Label2.Caption = "Confirm PassKey"
 .cmdUpdate.Caption = "Update PassKey"
End With
With frmMain
 .txtSurfTime.Text = "N/A"
 .cmdChgUserName.Caption = "Change PassKey"
End With
End Sub

Public Sub UserScreens()
With frmChgUserName
 .Caption = "Change Password"
 .Label1.Caption = "New Password"
 .Label2.Caption = "Confirm Password"
 .cmdUpdate.Caption = "Update User Password"
End With
frmMain.cmdChgUserName.Caption = "Change Password"
End Sub

Public Sub UpdateUserStats(PutTime As TextBox)
Set RS = DB.OpenRecordset("select * from SurfMonitor where user_id=" & Userid & "")
With RS
 .Edit
  !RemSurfTime = PutTime.Text
 .Update
End With
RS.Close
End Sub

Public Sub UpdateUserSurfTimes()

Set RS = DB.OpenRecordset("select * from SurfMonitor")
If RS.RecordCount <> 0 Then
 RS.MoveFirst
 While RS.AbsolutePosition <> -1
 
  With RS
   .Edit
   Period = DateDiff("d", CDate(!Currdate), Date)
   If Period > 0 Then
     If !Incremental = "YES" Then
       If !TimeLimit <> "" Then
         For i = 1 To Period
          If !RemSurfTime + !FullSurfTime <= !TimeLimit Then
            !RemSurfTime = !RemSurfTime + !FullSurfTime
           Else
            !RemSurfTime = !TimeLimit
            GoTo out
          End If
         Next
        Else
         For i = 1 To Period
          !RemSurfTime = !RemSurfTime + !FullSurfTime
         Next
       End If
out:
      Else
       !RemSurfTime = !FullSurfTime
     End If
   End If
   !Currdate = Date
   .Update
  End With
 
 RS.MoveNext
 Wend
End If
RS.Close
End Sub

Public Sub DisableTimers()
With frmMain
 .Timer.Enabled = False
 .tmrChkInetConnect.Enabled = False
 .tmrChkInetDisconnect.Enabled = False
 .tmrTimeRestrict.Enabled = False
 .tmrChkDateRollover.Enabled = False
End With
frmAutoExec.tmrUserInput.Enabled = False
End Sub

Public Sub FetchRegConstants()

Value = GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "SMVersion")
If Value <> "1.2.1" Then
  SetRegConstants
End If

FetchConfigDefaults

End Sub

Public Sub SetRegConstants()
CreateKey "HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor"
SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "MonUsers", "True"
SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "SMVersion", "1.2.1"
SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "ADenabled", "True"
SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "EnIconPath", App.Path & "\iusage.ico"
SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "DisIconPath", App.Path & "\iusage_dis.ico"
SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "UserSecs", "30"

Value = GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "Messiah")
If Value = "Error" Then
  SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "Messiah", ENCRYPT("MANAGER")
End If

SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "CLDaily", "False"
SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "CDate", Date
SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "FileCreated", "False"
End Sub

Public Function ENCRYPT(PASS As String) As String
Dim temp As String, asci As Integer

For i = 1 To Len(PASS)
    asci = Asc(Mid$(PASS, i, 1))
    asci = asci + 23
    temp = temp & Chr(asci)
Next
ENCRYPT = temp
End Function

Public Function DECRYPT(PASS As String) As String
Dim temp As String, asci As Integer

For i = 1 To Len(PASS)
    asci = Asc(Mid$(PASS, i, 1))
    asci = asci - 23
    temp = temp & Chr(asci)
Next
DECRYPT = temp
End Function

Public Sub FetchConfigDefaults()
USERTIMELEFT = Val(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "UserSecs"))
ENICONPATH = Trim(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "EnIconPath"))
DISICONPATH = Trim(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "DisIconPath"))
LOGCONSTANT = Trim(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "CLDaily"))
AutoExecEnabled = Trim(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "ADEnabled"))
LASTDATE = Trim(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "CDate"))
FILECREATED = Trim(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "FileCreated"))
MONUSERS = Trim(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\SurfMonitor", "MonUsers"))
End Sub

Public Function chkAccDisable() As Boolean
Set LRS_AccStatus = DB.OpenRecordset("select * from AccountStatus where user_id=" & Userid & "")

If LRS_AccStatus.RecordCount <> 0 Then
  With LRS_AccStatus
   If !AccDisable = "YES" Then
     If !AccEnDate <> "" Then
       If CDate(!AccEnDate) = Date Then
         chkAccDisable = False
         .Edit
          !AccDisable = "NO"
         .Update
         Exit Function
        ElseIf DateDiff("d", Date, !AccEnDate) = 1 Then
         chkDATE = !AccEnDate
         DtRestrict = EnAccountRestrictionsSet
         frmMain.tmrChkDateRollover.Enabled = True
       End If
     End If
     chkAccDisable = True
    Else
     If !AccDisDate <> "" Then
       If CDate(!AccDisDate) = Date Then
         chkAccDisable = True
         .Edit
          !AccDisable = "YES"
         .Update
         Exit Function
        ElseIf DateDiff("d", Date, !AccDisDate) = 1 Then
         chkDATE = !AccDisDate
         DtRestrict = DisAccountRestrictionsSet
         frmMain.tmrChkDateRollover.Enabled = True
       End If
     End If
     chkAccDisable = False
   End If
  End With
End If
DtRestrict = None
End Function

Public Function chkTimeRestrict() As Boolean
With LRS_TmRestrict
 If !Timefr = Time Then
   chkTimeRestrict = True
   Exit Function
 End If
 If Time > !Timefr Then
   If Time <= !Timeto Then
     chkTimeRestrict = True
     Exit Function
    Else
     chkTimeRestrict = False
     Exit Function
   End If
 End If
 chkTimeRestrict = False
End With
End Function
 
Public Sub LogUserDetails(Action As UserLogOptions)
Open App.Path & "\Userdets.sfm" For Append As #1
If Action = StartSurf Then
  Print #1, "----- " & Date & " ----------"
  Print #1, "User ID    - " & Userid
  Print #1, "User NM   - " & DECRYPT(Usernm)
  Print #1, "Login at   : " & Time
  WrittenStartDetails = True
 ElseIf Action = StopSurf And WrittenStartDetails = True Then
  Print #1, "Logout at : " & Time
  Print #1, "Surf Time : " & TimeDiff(StartTIMESTAMP, startDATESTAMP, stopTIMESTAMP, stopDATESTAMP)
  Print #1, "---------------------------------"
  Print #1, ""
  WrittenStartDetails = False
End If
Close #1
End Sub

Public Function TimeDiff(LesserTime As String, LesserTimeDate As String, GreaterTime As String, GreaterTimeDate As String) As String
Dim Thrs As Single, Tmins As Single, Tsecs As Single, ReturnTime As String
Dim DTcheck As Single, TempHR As Integer
DTcheck = DateDiff("d", LesserTimeDate, GreaterTimeDate)

If DTcheck > 0 Then
  TempHR = Hour(GreaterTime)
  For i = 1 To DTcheck
    TempHR = TempHR + 24
  Next
 ElseIf DTcheck < 0 Then
  TimeDiff = "ERROR"
  Exit Function
End If
  
If DTcheck > 0 Then
  Thrs = TempHR - Hour(LesserTime)
 Else
  Thrs = Hour(GreaterTime) - Hour(LesserTime)
End If

If Thrs > 0 Then
  Tmins = Minute(GreaterTime) - Minute(LesserTime)
  If Tmins < 0 Then
    Tmins = Tmins + 60
    Thrs = Thrs - 1
  End If
 ElseIf Thrs = 0 Then
  If Minute(GreaterTime) >= Minute(LesserTime) Then
    Tmins = Minute(GreaterTime) - Minute(LesserTime)
  End If
 Else
   TimeDiff = "ERROR"
   Exit Function
End If
  
Tsecs = Second(GreaterTime) - Second(LesserTime)
If Tsecs < 0 Then
  Tsecs = Tsecs + 60
  If Tmins > 0 Then Tmins = Tmins - 1 Else Tmins = 59
End If

TimeDiff = TimeSerial(Thrs, Tmins, Tsecs)

End Function

